(*--------------------------------------------------------------------------*)
(*  Santronics Software, Co.                                                *)
(*  30034 SW 153 Ct.                                                        *)
(*  Leisure City, FL  33033                                                 *)
(*                                                                          *)
(*                                                                          *)
(*             (C) Copyright 1988-95, Santronics Software, Co               *)
(*                                                                          *)
(*--------------------------------------------------------------------------*)

UNIT BitSet;

INTERFACE

Type Set32Type    = Array[1..32] of Byte;
Type SetMType     = Array[1..4096] of Byte;
Type pSetMType    = ^SetMType;

Function  IsBitSet(Flag : word; Source : word) : Boolean;
Function  IsLongBitSet(Flag : LongInt; Source : LongInt) : Boolean;
Procedure SetByteBit(Var v : byte;  bit : byte; OnOff : Boolean);
Procedure SetWordBit(Var v : word; bit : word; OnOff : Boolean);
Procedure SetLongBit(Var v : longint; bit : longint; OnOff : Boolean);
Procedure AreaIndexBit(a:word; var i,b : word);
Procedure SetAreabit(Var SetP;A:word);
Procedure UnSetAreabit(Var SetP;A:word);
Procedure ToggleAreabit(Var SetP;A:word);
Function  IsAreaSelected(var SetP; A:word):Boolean;

IMPLEMENTATION

Function IsBitSet(Flag : word; Source : word) : Boolean;
(*
  return true/false if SOURCE has the flag bit(s) set
  flag   - bit(s) flag;    source - value to compare
*)
  Begin
    IsBitSet := (Flag and Source) = Flag;
  End;

Function IsLongBitSet(Flag : LongInt; Source : LongInt) : Boolean;
  Begin
    IsLongBitSet := (Flag and Source) = Flag;
  End;

Procedure SetWordBit(Var v : word; bit : word; OnOff : Boolean);
  begin
   If OnOff
      then v := v or bit
      else v := v and (not bit);
  end;

Procedure SetLongBit(Var v : Longint; bit : Longint; OnOff : Boolean);
  begin
   If OnOff
      then v := v or bit
      else v := v and (not bit);
  end;

Procedure SetByteBit(Var v : byte; bit : byte; OnOff : Boolean);
  begin
   If OnOff
      then v := v or bit
      else v := v and (not bit);
  end;

Procedure AreaIndexBit(a:word; var i,b : word);
(*
  this procedure returns the index and bit position for the area #
     a - input, area # 0 - 255.
     i - the index of 1 to 32 where area # fits.
     b - the bit position of the area # within the index

  ie, area 33 should return  i = 5 and b = 1.
*)
  begin
      i := (a div 8)+1;
      b := (a mod 8);
  end;

Procedure SetAreabit(Var SetP;A:word);
(*
 Given the 32 byte array of areas, and area #, set the bit representing
 the area.
*)
var i,b   : word;
    SetM  : SetMType absolute SetP;
  begin
      AreaIndexBit(a,i,b);
      SetM[i] := SetM[i] or (1 shl b);
  end;

Procedure UnSetAreabit(Var SetP;A:word);
(*
 Given the 32 byte array of areas, and area #, Unset the bit representing
 the area.
*)
var i,b : word;
    SetM  : SetMType absolute SetP;
  begin
      AreaIndexBit(a,i,b);
      SetM[i] := SetM[i] and ((1 shl b) XOR $FF);
  end;

Procedure ToggleAreabit(Var SetP;A:word);
(*
 Given the 32 byte array of areas, and area #, toggle the bit representing
 the area.
*)
var i,b : word;
    SetM  : SetMType absolute SetP;
  begin
      AreaIndexBit(a,i,b);
      SetM[i] := SetM[i] XOR (1 shl b);
  end;


Function IsAreaSelected(var SetP; A:word):Boolean;
(*
 Given the 32 byte array of areas, and area #, determin if
 the area is selected.
*)
var i,b   : word;
    SetM  : SetMType absolute SetP;
  begin
      AreaIndexBit(a,i,b);
      IsAreaSelected  := IsBitSet( (1 shl b), SetM[i]);
  end;
end.
