(**************************************************************************
               copyright (c) 1988-1994 by Santronics Software
                            All Rights Reserved
***************************************************************************)

{$A-}
UNIT CONTROL;

(* structure of PRM file *)

INTERFACE

Uses XpLimits;

Type  NetAddressType =
           record
             Zone, Net, Node, Point : word;
             Domain                 : string[15];
           end;

Const
  useDisk  = 0;
  UseEMS   = 1;
  UseXMS   = 2;

Const CONTROL_VERSION = $0503;

const
 rampos1 : byte = $FF;   (* first byte written to prm file *)
  _ctl_control_id      : word       = CONTROL_VERSION;
  _ctl_bbs_version     : string[20] = '';              (* BBS version         *)
  _ctl_xpsystem_path   : string[50] = '\xpress';       (* Xpress system files *)
  _ctl_zone            : word       = 0;
  _ctl_net             : word       = 0;
  _ctl_node            : word       = 0;
  _ctl_point           : word       = 0;
  _ctl_domain          : string[15] = '';
  _ctl_MHS_Gateway     : string[30] = '';
  _ctl_Old_regcode     : string[8]  = '';
  _ctl_New_regcode1    : string[8]  = '';
  _ctl_New_regcode2    : string[8]  = '';
  _ctl_sysop_name      : string[50] = '';
  _ctl_board_name      : string[60] = '';              (* short bbs name      *)
  _ctl_boardid         : string[8]  = '';              (* opx file name       *)
  _ctl_bbssystem_path  : string[50] = '';              (* location of BBS system *)
  _ctl_bbsmail_path    : string[50] = '';              (* location of mail bases *)
  _ctl_nodelist_path   : string[50] = '';
  _ctl_lastuser_file   : string[50] = '';
  _ctl_def_origin      : string[70] = 'Silver Xpress Mail System';
(*-*)
  _ctl_log_file        : string[50] = '\xpress\xlog.log';
  _ctl_work_path       : string[50] = '\xpress\work';
  _ctl_dlfiles_path    : string[50] = '';
  _ctl_xpstats_file    : string[50] = '\opus\xpstats.dat';
  _ctl_sched_file      : string[50] = '\opus\sched.bbs';
  _ctl_logintime_file  : string[50] = '\opus\system.bbs';
  _ctl_echotoss_file   : string[50] = '\opus\echotoss.log';
  _ctl_dnld_path       : string[50] = '\xpress\down';
  _ctl_upld_path       : string[50] = '\xpress\up';
  _ctl_dump_path       : string[50] = '\xpress\dump';
  _ctl_misc_path       : string[50] = '\xpress\misc';   (* not used *)
  _ctl_bulletin_path   : string[50] = '\xpress\bull';
  _ctl_fupload_path    : string[40] = '\xpress\fileupld';
  _ctl_extra_path      : string[40] = '\xpress\extra';
  _ctl_Swap_Path       : string[50] = '';
  _ctl_snoop           : boolean    = TRUE;
  _ctl_carrier         : boolean    = TRUE;
  _ctl_kbrd_response   : integer    = 180;
  _ctl_reboot          : boolean    = FALSE;
  __ctl_abortable       : boolean    = FALSE;  (* 5.04 always false *)
  _ctl_msglimit        : word       = 0;       {0-no limit}
  _ctl_bells           : BOOLEAN    = TRUE;
  _ctl_signatures      : boolean    = true;
  _ctl_freq_limit      : byte       = 10;      {0- no File Requesting allowed}
  _ctl_new_messages    : word       = 500;
  _ctl_obselete_1      : boolean    = false;
  _ctl_prompt_time     : word       = 15;      (* # of secs to wait for dl *)
  _ctl_sound_delay     : integer    = 150;
  _ctl_sound_freq      : integer    = 2000;
  _ctl_service_area    : integer    = 1;
  _ctl_max_dupes       : integer    = 1000;
  _ctl_nodelist_ver    : string[4]  = 'X1';
  _ctl_ok_xprversion   : string[15] = '2.28';
  _ctl_desqv_shadow    : boolean    = false;
  _ctl_multi_line      : byte       = 0;    (* 1-DQ, 2-NETBIOS, 3-NOVELL *)
  _ctl_multi_task      : byte       = 0;    (* 1-DQ, 2-AT BIOS *)

  _ctl_aka_address     : Array[1.._MaxAka] of NetAddressType
                            =
                             (
                             (Zone:0;Net:0;Node:0;Point:0;Domain:''),
                             (Zone:0;Net:0;Node:0;Point:0;Domain:''),
                             (Zone:0;Net:0;Node:0;Point:0;Domain:''),
                             (Zone:0;Net:0;Node:0;Point:0;Domain:''),
                             (Zone:0;Net:0;Node:0;Point:0;Domain:'')
                             );

  _ctl_fupload_limit   : integer    = 5;
  _ctl_OverlaySize     : byte       = 64;      (* 5.04, formerly _ctl_useSwap *)
  _ctl_SwapStorage     : byte       = useDisk; (* 5.04 *)
  _ctl_NewUser_macro   : string[60] = '';
  _ctl_user_log_on     : boolean    = true;

  _ctl_secret_name     : string[35] = '';     (* P1/R1 ONLY STUFF *)
  _ctl_main_user_file  : string[50] = '';     (* PCB/RBBS only. *)
  _ctl_indiv_offset    : byte       = 0;
  _ctl_indiv_len       : byte       = 0;
  _ctl_pcbfidondx_file : string[50] = '';     (* Was _ctl_main_msg_file, now
                                                 path to PCB's FIDOAREA.NDX
                                              *)

  _ctl_text_editor     : string[50] = '';     (* XPADM Text Editor *)
  _ctl_ansi_editor     : string[50] = '';     (* XPADM Ansi Editor *)

  _ctl_use_int_editor  : boolean    = false; (* use internal editor for xpadm *)
  _ctl_OverlayStorage  : byte       = useDisk;  (* 5.04 *)

  _ctl_echoorig_file   : string[50] = '';
  _ctl_flsearch_file   : string[50] = '';

  _ctl_hms_model       : byte       = 0;  (* see hmsfmt.pas  *)

  _ctl_help_path       : string[50]  = '\xpress\help';
  _ctl_dump_badnet     : boolean     = false;
  _ctl_cost_badnet     : word        = 25;  (* cents *)
  _ctl_sysop_convert   : boolean     = true;  (* SYSOP name convert *)

  _ctl_net_crash       : word        = 0;
  _ctl_net_fattach     : word        = 0;
  _ctl_net_freq        : word        = 0;
  _ctl_net_immed       : word        = 0;
  _ctl_net_direct      : word        = 0;
  _ctl_net_hold        : word        = 0;
  _ctl_net_killfile    : word        = 0;
  _ctl_net_killmsg     : word        = 0;
  _ctl_alias_system    : boolean     = false;
  _ctl_force_intl      : boolean     = false;
  _ctl_bbs_phone       : string[25]  = '';
  __ctl_local_dosswap  : boolean     = true;    (* 5.04, always true *)
  _ctl_edi_path        : string[50]  = '';


  _ctl_comm_port       : word        = 1;       (* 1 based *)(* 176 *)
  _ctl_fossil_on       : boolean     = TRUE;
  _ctl_fossil_TXON     : boolean     = TRUE;
  _ctl_fossil_RXON     : boolean     = TRUE;
  _ctl_fossil_FCTS     : boolean     = TRUE;
  _ctl_fossil_dos_off  : boolean     = TRUE;
  _ctl_locked_baud     : longint     = 19200;

  _ctl_rip_clrcolor    : byte        = 7;      (* 4.02, clearing color        *)
  _ctl_rip_exit_off    : boolean     = TRUE;   (* 4.02, turn off upon exit    *)
  _ctl_rip_menu        : byte        = 1;      (* 4.02, use internal menu     *)
  _ctl_rip_echo        : boolean     = FALSE;  (* 4.02, local echo            *)
  _ctl_rip_detect      : byte        = 0;      (* 4.02, NEVER, ALWAYS, CONFIRM *)

  _ctl_skip_cdrom      : boolean     = FALSE;  (* 4.02, skip cdrom listings   *)
  _ctl_force_selected  : boolean     = TRUE;   (* 4.01, Force Sysop Selection *)

  _ctl_cvtsysop_dnld   : boolean     = FALSE;
  _ctl_cvtsysop_upld   : boolean     = FALSE;
  _ctl_fossil_flush    : boolean     = TRUE;

  _ctl_true_sysop      : boolean     = TRUE;
  _ctl_use_lread       : boolean     = TRUE;
  _ctl_bbsuser_file    : string[50]  = '';
  _ctl_use_autolocal   : boolean     = false;   (* 101,255 *)

  _ctl_sysop_dnpath    : string[50]  = '';    (* local mode sysop dl path *)
  _ctl_sysop_uppath    : string[50]  = '';    (* local mode sysop ul path *)
  _ctl_sysop_wkpath    : string[50]  = '';    (* local mode sysop work path *)
  _ctl_sysop_renopx    : boolean     = FALSE; (* rename the packet? *)
  _ctl_sysop_delrep    : boolean     = FALSE; (* delete the reply file? *)

  _ctl_logoff_hangup   : boolean     = TRUE;  (* for PCBoard It's false *)
  _ctl_bbs_logfile     : string[50]  = '';    (* BBS Log File *)
  _ctl_asstsysop_name  : string[35]  = '';
  _ctl_city_state      : string[30]  = '';    (* for QWK packet *)

  _ctl_bbsfiles_path   : string[40]  = '';    (* RA111  not used *)
                                              (* RA - Location of TXT, HDR, TXT *)
                                              (* TAG- Location of Mail DFILES   *)
                                              (* PCB- Location of DIR.LST file  *)
  _ctl_area_scan_limit : word        = 0;
  _ctl_hangup_delay    : word        = 500;   (* 4.01. Delay For DTR lowering *)
  _ctl_uucp_zone       : word        = 0;     (* 5.01  UUCP routing *)
  _ctl_uucp_net        : word        = 0;
  _ctl_uucp_node       : word        = 0;
  _ctl_uucp_point      : word        = 0;
  _ctl_semaphore_flags : word        = 0;     (* see below *)
  _ctl_force_net_flags : word        = 0;     (* see net flags in xpcommon *)
  _ctl_jaminternet     : boolean     = TRUE;  (* Merlin Systems JAM method *)
  _ctl_force_secured   : boolean     = FALSE; (* Force Area only if Secured *)
  _ctl_AckReceipt      : Boolean     = TRUE;
  _ctl_MatchBBSConf    : Boolean     = FALSE;
  _ctl_irq_number      : word        = 0;     (* 0 standard  *)
  _ctl_base_address    : word        = 0;     (* 0 standard  *)
  _ctl_sec_freq        : word        = 0;     (* 5.01  Freq Security PCB      *)
  _ctl_usePCB15ForQwk  : Boolean     = FALSE;
  _ctl_pcb_no_E3       : boolean     = FALSE; (* 5.00 pcboard only *)
  _ctl_serial_code     : string[10]  = '';    (* 5.00 *)
  _ctl_auto_node       : boolean     = True;  (* for novell *)
  _ctl_node_task_id    : byte        = 0;     (* for novell *)

  _ctl_mail_required   : boolean     = TRUE;
  _300_END_LOCATION    : byte        = 0;     (* 3.00 ends here ***********)
  _ctl_newfiles_list   : string[50]  = '';
  _ctl_cnames_fn       : string[50]  = '';    (* PCBOARD           *)
  _ctl_pcb_fsec_fn     : string[50]  = '';    (* PCBOARD FSEC file *)

{ This use to be the QFRONT location

            Location of QFRONT
         or Path to PCBFIDO.CFG
}

  _ctl_qfront_path     : string[50]  = '';    (* Generic FidoCfg Path *)

  _ctl_Scan_ReadOnly   : boolean     = FALSE; (* Btree AllREadOnly Open Flag *)
  _ctl_Pack_ReadOnly   : boolean     = FALSE; (* Btree AllREadOnly Open Flag *)
  _ctl_fscan_readonly  : boolean     = FALSE; (* Btree AllREadOnly Open Flag *)
  _ctl_internet_domain : string[80]  = '';    (* 5.01 ends here ***********)
  _ctl_internet_host   : string[80]  = '';
  _ctl_first_time_date : word        = 0;
  _ctl_fifo_trigger    : byte        = 4;     (* 5.04 *)
  _ctl_sec_tomacros    : word        = 0;     (* 5.04, security to @To@ macros *)
  _ctl_pcb_fido        : boolean     = FALSE; (* 5.04, PCB 15.2 fido enabled *)
  _ctl_pcbfidocfg_file : string[50]  = '';
  _ctl_sec_vacpac      : word        = 0;     (* 5.3e, sec for vac packets   *)
  _ctl_sec_filereq     : word        = 0;     (* 5.3e, sec for file request  *)
  _ctl_sec_filescan    : word        = 0;     (* 5.3e, sec for file scan     *)
  _ctl_sec_forward     : word        = 0;     (* 5.3e, sec for msg forward   *)
  reserved_area5       : string[239] = '';    (* 5.03 ends here **********)
 rampos2 : byte = $FF;                     (* Not written to prm file *)

(*************************************************************************)


Const
    Using_SX_READER    : Boolean    = FALSE;
    ctl_ctl_name       : string[50] = 'xpmail.ctl';
    ctl_prm_name       : string[50] = 'xpmail.prm';
    def_file_name      : string[50] = 'xpareas.ctl';
    def_fido_file_name : string[50] = 'xpfido.ctl';
    raw_file_name      : string[50] = 'xpareas.raw';
    dat_file_name      : string[50] = 'xpareas.dat';
    adx_file_name      : string[50] = 'xpareas.adx';
    usr_file_name      : string[50] = 'xpuser.dat';
    xua_file_name      : string[50] = 'xpuser.xua';
    raw_freq_name      : string[50] = 'xpfiles.raw';
    dat_freq_name      : string[50] = 'xpfiles.dat';
    XpSwapFileName     : String[50] = 'xpmail.sw$';  (* obsletete, dynamic *)

    ctl_menu_name      : string[50] = 'xpmenu.ctl';
    ctl_lang_name      : string[50] = 'xplang.ctl';
{$IFDEF OS2}
    ctl_arch_name      : string[50] = 'xparch2.ctl';
    ctl_prot_name      : string[50] = 'xpprot2.ctl';
{$ELSE}
    ctl_arch_name      : string[50] = 'xparch.ctl';
    ctl_prot_name      : string[50] = 'xpprot.ctl';
{$ENDIF}
    ctl_limits_name    : string[50] = 'xplimits.ctl';
    ctl_irrport_file   : string[50] = 'irrport.ctl';
    pkt_ext            : string[5]  = 'opx';

    ctl_begin_subdir   : string[50] = '';
    ctl_finish_subdir  : string[50] = '';
    NetWorkSysop       : Boolean    = False;

var fvctl              : file;
    ctlrecsize         : word;

(* Semaphore flags *)

Const
    _sema_uucp         =  $0001;           (* $UUCP.SEM           *)
    _sema_usenet       =  $0002;           (* $USENET.SEM         *)
    _sema_local        =  $0004;           (* $LOCAL.SEM          *)
    _sema_echo         =  $0008;           (* $ECHO.SEM           *)
    _sema_netmail      =  $0010;           (* $NET.SEM            *)
    _sema_echonet      =  $0020;           (* $ECHONET.SEM        *)
    _sema_goodbye      =  $0040;           (* $LOGOUT.SEM         *)
    _sema_exit         =  $0080;           (* $EXIT.SEM           *)

IMPLEMENTATION
END.

