{$A-}

(*
This is the ADAM HUDSON format for messages and some common variables
between easy HMS bbs.
*)

UNIT HMSFMT;

INTERFACE

CONST _MAX_HMS_AREAS = 200;
      _HMS_QS264     = 1;      (* HMS MODELS *)
      _HMS_QS275     = 2;
      _HMS_QS276     = 2;
      _HMS_RA111     = 3;
      _HMS_RA200     = 4;
      _HMS_ROBO      = 5;
      _HMS_SUPER     = 6;
      _HMS_TAG       = 7;
      _HMS_PB        = 8;      (* Proboard *)
      _HMS_PB202     = 9;      (* Proboard 2.02 *)
      _HMS_QS280     = 10;     (* GOLDBASE *)

Type
  FlagType       = array[1..4] of Byte;

  MSGINFOrecord  = record
                     LowMsg,
                     HighMsg,
                     TotalMsgs      : Word;
                     TotalOnBoard   : array[1.._MAX_HMS_AREAS] of Word;
                   end;

  MSGIDXrecord   = record
                     MsgNum         : Integer;
                     Board          : Byte;
                   end;

  MSGTOIDXrecord = String[35];

  MSGHDRrecord   = record
                     MsgNum         : Integer;
                     PrevReply,
                     NextReply,
                     TimesRead      : Word;
                     StartBlock     : Word;
                     NumBlocks,
                     DestNet,
                     DestNode,
                     OrigNet,
                     OrigNode       : Word;
                     DestZone,
                     OrigZone       : Byte;
                     Cost           : Word;
                     MsgAttr,
                     NetAttr,
                     Board          : Byte;
                     PostTime       : String[5];
                     PostDate       : String[8];
                     WhoTo,
                     WhoFrom        : MSGTOIDXrecord;
                     Subject        : String[72];
                   end;

  MSGTXTrecord   = String[255];

  LASTREADrecord = array[1.._MAX_HMS_AREAS] of Word;


(* Msg Attributes:

      Bit 0: Deleted
      Bit 1: Unmoved Outgoing Net Message
      Bit 2: Is a Net Mail Message
      Bit 3: Private
      Bit 4: Received
      Bit 5: Unmoved Outgoing Echo Message
      Bit 6: Local Bit
      Bit 7: [ Reserved ]

   Net Attributes:

      Bit 0: Kill Message after it's been sent
      Bit 1: Sent OK
      Bit 2: File(s) Attached
      Bit 3: Crash Priority
      Bit 4: Request Receipt
      Bit 5: Audit Request
      Bit 6: Is a Return Receipt
      Bit 7: [ Reserved ]

*)

(* Msg Attributes  *)
 
Const
     QM_DELETED    =  $01;     (* Bit 0: Deleted *)
     QM_OUTNET     =  $02;     (* Bit 1: Unmoved Outgoing Net Message *)
     QM_NETMAIL    =  $04;     (* Bit 2: Is a Net Mail Message *)
     QM_PRIVATE    =  $08;     (* Bit 3: Private *)
     QM_RECEIVED   =  $10;     (* Bit 4: Received *)
     QM_OUTECHO    =  $20;     (* Bit 5: Unmoved Outgoing Echo Message *)
     QM_LOCAL      =  $40;     (* Bit 6: Local Bit *)
     QM_JUNKMAIL   =  $80;     (* Bit 7: [ SX JUNKMMAIL ] *)
 
(* Net Attributes: *)

Const
 
     QM_KILL       =  $01;     (* Bit 0: Kill Message after it's been sent *)
     QM_SENT       =  $02;     (* Bit 1: Sent OK *)
     QM_ATTACHED   =  $04;     (* Bit 2: File(s) Attached *)
     QM_CRASH      =  $08;     (* Bit 3: Crash Priority *)
     QM_RECEIPT    =  $10;     (* Bit 4: Request Receipt *)
     QM_AUDIT      =  $20;     (* Bit 5: Audit Request *)
     QM_RETURN     =  $40;     (* Bit 6: Is a Return Receipt *)
                               (* Bit 7: [ Reserved ] *)


(*  Board types  *)

Const

     QM_ECHO_TYPE    = 3;
     QM_EMAIL_TYPE   = 2;
     QM_NET_TYPE     = 1;
     QM_LOCAL_TYPE   = 0;


Function RoboFlags2Byte(Var Flags8ptr) : byte;

IMPLEMENTATION

Function RoboFlags2Byte(Var Flags8ptr) : byte;
var f : array[1..8] of boolean absolute flags8ptr;
     i, r : byte;
  begin
    r := 0;
    for i := 1 to 8 do if f[i] then r  := r or (1 shl (i-1));
    RoboFlags2Byte := r;
  end;

END.
