(*--------------------------------------------------------------------------*)
(*  Santronics Software, Co.                                                *)
(*  30034 SW 153 Ct.                                                        *)
(*  Leisure City, FL  33033                                                 *)
(*                                                                          *)
(*                                                                          *)
(*             (C) Copyright 1988-95, Santronics Software, Co               *)
(*                                                                          *)
(*--------------------------------------------------------------------------*)

(*

To use this unit, you must define ONLY ONE compiler directive appropiate
for your BBS system

*)

{.$DEFINE F}            (* Max & Opus Systems)
{.$DEFINE H1}           (* RA, QBBS, PROBOARD, TAG, ROBOFX *)
{.$DEFINE P1}           (* PCBOARD *)
{.$DEFINE R1}           (* RBBS *)
{.$DEFINE W1}           (* WILDCAT *)

{* Definition Outline for all the models of Silver Xpress            *)

{$IFNDEF F}
 {$IFNDEF H1}
  {$IFNDEF P1_R1_W1}
Declare compiler condition: F, H1, P1, R1 or W1
  {$ENDIF}
 {$ENDIF}
{$ENDIF}

{$IFDEF P1}
{$DEFINE P1_R1_W1}
{$ENDIF}
{$IFDEF R1}
{$DEFINE P1_R1_W1}
{$ENDIF}
{$IFDEF W1}
{$DEFINE P1_R1_W1}
{$ENDIF}


{$A-}

Unit XpMArea;

INTERFACE

Uses dos,
     hmsfmt,
     fidofmt;

{$IFDEF F}  (* this is used for Maximus and OPUS systems *)


Type dor_areatype
       = Record
          area         : word;         (* area number *)
          area_name    : string[39];   {MAX ONLY. area string name}
          areano       : integer;      {MAX ONLY. area no as defined by max}
          defined      : boolean;      {defined by XPADM }
          selected     : boolean;
          area_priv    : word;         {Privs}
          area_lock    : longint;      {NOT USED IN F1}
          private_priv : word;         {NOT USED IN F1,F2}
          private_lock : longint;      {NOT USED IN F1,F2}
          edit_priv    : integer;      {NOT USED IN F1,M1}
          edit_lock    : longint;      {NOT USED IN F1,M1}
          oaccess      : word;         {Xpress OverRide}
          attrib       : MsgAttribType;{type of area. Array of
                                        Attrib based on user's priv}
          mailform     : Byte;         {type of area}
          msgpath      : string[50];
          filepath     : string[50];
          stitle       : string[20];
          ltitle       : string[50];
          echoname     : string[20];
          Origin       : string[60];
          password     : string[20];   {was 30 length}
          Xflags       : byte;         {Xpress Flags}
          Orig_aka_idx : byte;         {Max Only}
          rdrbits      : byte;         {Reader Bits. See above}
          Zone         : word;
          Net          : word;
          Node         : word;
          Point        : word;
          Domain       : string[15];
          Volume_Id    : String[11];
          area_type    : word;         (* max only, squish or fido *)
          mailtype     : byte;
          scanmsgmax   : word;         (* maximum mail to scan  0 - none*)
          reserved     : array[1..32] of byte;
         end;
{$ENDIF}

{$IFDEF H1}  (* This is used for HMS systems *)

Type BoardRecordType  =  (* MY VERSION OF BOARD INFO *)
          record
            areatype       : byte; (* 0 - local, 1-net, 2,3=echo *)
            AkaIndex       : Byte;
            OriginLine     : String[60];
            Combined       : Boolean;
            Attribute      : Byte;

             { Bit 0 : Enable EchoInfo      0
                   1 : Combined access      2
                   2 : File attaches        4
                   3 : Allow aliases        8
                   5 : Force handle        32  }

            ReadSecurity   : Word;
            ReadFlags      : FlagType;
            WriteSecurity  : Word;
            WriteFlags     : FlagType;
            SysopSecurity  : Word;
            SysopFlags     : FlagType;
            Zone           : word;       (* not used *)
            net            : word;       (* not used *)
            node           : word;       (* not used *)
            point          : word;       (* not used *)
            domain         : string[12];
            reserved       : array[1..9] of byte;
          end;

Type dor_areatype
       = Record
          selected   : boolean;      {selected by user      }
          defined    : boolean;      {defined by XPADM }
          area       : word;         {Area Number}
          area_priv  : word;         {access for area, not required}
          attrib     : byte;         {type of area}
          oaccess    : word;
          Board      : BoardRecordType;
          MailType   : Byte;         { mail type, local, echo, net}
          MailForm   : Byte;         { mail format, RBBS, FIDO, QBBS, SQUISH, etc}
          stitle     : string[20];
          ltitle     : string[50];
          password   : string[30];   {for additional security}
          Xflags     : byte;         {Xpress Flags}
          rdrbits    : byte;         {Reader Bits. See above}
          EchoName   : String[30];
          MsgPath    : String[50];
          ra_boardnum: word;
          scanmsgmax : word;         (* maximum mail to scan  0 - none*)
          ReadNOTFlags  : FlagType;  (* RA 2.0 ONLY *)
          WriteNOTFlags : FlagType;
          SysopNOTFlags : FlagType;
          reserved   : array[1..64] of byte;
         end;
{$ENDIF}

{$IFDEF P1_R1}  (* This is for PCBOARD or RBBS systems *)
Type dor_areatype
       = Record
          selected   : boolean;      {selected by user      }
          defined      : boolean;      {defined by XPADM }
          area_priv  : word;         {access level }
          attrib     : word;         {type of area, alias, pri/pub }
          area       : word;         {area number}
          oaccess    : word;         {xpress overwrite access level}
          areasysop  : string[32];   {* moderator                     *}
          echoname   : string[20];
          password   : string[20];   {xpress password entry  }
          stitle     : string[20];
          ltitle     : string[50];
          origin     : string[60];
          autolevel  : word;         {* acces required to carry sec   *}
          MsgPath    : string[50];   {* short path for messages       *}
          UsrPath    : string[50];   {* short path for user file      *}
          MaxMsgLine : Word;         {* msg max line allowed          *}
          MaxMsg     : Word;         {* max messages allowed          *}
          MailType   : Byte;         {* mail type, local, echo, net   *}
          MailForm   : Byte;         {* mail format, RBBS, FIDO, QBBS *}
          ReadPub    : Word;         {* Read private access           *}
          ReadPri    : Word;         {* Read priv access              *}
          PostPub    : Word;         {* post private access           *}
          PostPri    : Word;         {* post priv access              *}
          PostAnon   : word;         {* post anonymous mail access    *}
          scanmsgmax : word;         (* maximum mail to scan  0 - none*)
          Elastic    : boolean;      {* mail flexible                 *}
          public     : boolean;      (* PCB ONLY. conference public.  *)
          Volume_Id  : String[11];
          rdrbits    : byte;         {Reader Bits. See above}
          Xflags     : byte;         (* Xpress Flags                  *)
        end;
{$ENDIF}

Const FIDO_MAIL         = 1;       (* must match areas.def (RBBS ONLY) *)
      RBBS_MAIL         = 2;
      HMS_MAIL          = 3;
      PCBOARD_MAIL      = 4;
      MHS_MAIL          = 5;
      SQUISH_MAIL       = 6;
      FAX_MAIL          = 7;
      TEXT_MAIL         = 8;
      JAM_MAIL          = 9;
      MAIL_ALL_FORMS    = 99;

      MAIL_LOCAL        = 0;
      MAIL_ECHO         = 1;
      MAIL_NET          = 2;
      MAIL_FAX          = 3;
      MAIL_ALL_TYPES    = 99;

Const MailTypeStr : Array[MAIL_LOCAL..MAIL_FAX] of String[7]
                     = ('LOCAL','ECHO','NETMAIL','FAX');

Const MailFormStr : Array[FIDO_MAIL..SQUISH_MAIL] of String[7]
                     = ('FIDO','RBBS','HMS','PCBOARD','MHS','SQUISH');


(* This is a special index file for Silver Xpress. Must be created *)

type _xpaidx =
       record
         offset    : longint;     (* offset to XPAREAS.DAT *)
         area      : word;        (* MAX: Index, Others Real Area Number*)
         echo_crc  : longint;     (* crc of echo tag or LOCAL_areanum *)
       end;

implementation

end.


