{$A-}
UNIT XPUSER;


Interface

uses
     xplimits;

(* VERSION ID: *)

Const _XPUSERID = $0500;

type _xpusertype =
     record
       FormatStamp    : Longint;            (* Format #. SHOULD BE $5000 *)
       recsize        : longint;
       _internal_only : word;               (* see Below *)
       recstatus      : integer;
       name           : string[35];         {user's name/REGISTER NAME}
       alias          : string[35];         {user's alias name}
       MHSUserName    : string[8];          {user's MHS name}
       internet       : string[60];         {user's internet address}
       urdrbits       : byte;               {user reader bits}
       reserved       : array[1..8] of char;
       FreqAttempts   : Word;
       pktcount       : word;
       flags1         : FlagMatrix;         {see below}
       flags2         : FlagMatrix;
       flags3         : FlagMatrix;
       Protocolch     : char;               {transfer Protocol}
       Archiverch     : char;               {archiver Protocol}
       menumode       : byte;               {see comm_io for levels }
       LastDateStamp  : Longint;            {last timestamp}
       FirstDatestamp : Longint;            {first time usage}
       msg_limit      : word;               {reader new mail limit}
       times          : word;               {number of downloads usage}
       door_pw        : string[10];
       rdr_pw         : string[10];
       ExtraID        : longint;            (* FUTURE. File ptr *)
       nldate         : longint;            (* date of xpnlv1.idx file *)
       NetMailFlags   : word;
       Credit         : Word;
       Debit          : Word;
       mail_pkt       : byte;               (* _pkt_??? in xplimits *)
       SeenDoor       : byte;               (* Internal *)
       Security       : word;
       totalgrps      : byte;
       group          : GroupListType;
       time_prompt    : word;
       QwkHdrCase     : Byte;               {0-As Is, 1-Caps, 2-UpcaseAll, 5.03}
       extra          : array[1..47] of byte;
    end;

Const
    SeenDoor_301  = $0001;
    SeenDoor_500  = $0002;

Type
     xpuserfiletype   = file of _xpusertype;

(******************************************************************************
   Flags bit settings for arrays FLAGS1, FLAGS2 and FLAGS3
*******************************************************************************)

CONST
(* flag set 1 byte 1 *)
      usr_graphics     = $01; (* USER     ansi graphics                       *)
      usr_menuhotkeys  = $02; (* USER     menu hot keys                       *)
      usr_tomacro      = $04; (* USER     allow !ALL! translations            *)
      usr_ownmail      = $08; (* USER     allow user to receive own mail      *)
      usr_sysop        = $20; (* SYSOP    xpress sysop menu                   *)
      usr_abuser       = $40; (* SYSOP    do not allow user into door         *)
      usr_signature    = $80; (* SYSOP    allow user to use signature         *)

(* flag set 1 byte 2 *)
      usr_avatar       = $01; (* AUTO     Use avatar code                     *)
      usr_upload       = $02; (* SYSOP    file upload allowed                 *)
      usr_filescan     = $04; (* USER     file scan                           *)
      usr_forward      = $08; (* SYSOP    forwarding allowed                  *)
      usr_dnload       = $10; (* SYSOP    file download allowed               *)
      usr_showmailonly = $40; (* User     show areas with mail during scan    *)
      usr_faxx         = $80; (* SYSOP    can use FaXXpress                   *)

(* flag set 1 byte 3 *)
      usr_xpv1netfiles = $01; (* USER     Attach Xpress NetFiles V1           *)
      usr_xpv2netfiles = $02; (* USER     Attach Xpress NetFiles V2           *)
      usr_xpsaver      = $04; (* USER     Xpress Vacation Saver               *)
      usr_newsbull     = $08; (* USER     include news bulletin               *)
      usr_ibmchar      = $10; (* USER     ibm characters                      *)
      usr_reprcp       = $20; (* USER     reply upload receipt wanted         *)
      usr_qwksendndx   = $40; (* USER     send ndx files to users             *)
      usr_qwkstripk    = $80; (* USER     no kludges in mail for qwk packet   *)

(* flag set 1 byte 4 *)

      usr_autostart    = $01; (* USER     User Requested to auto start Door   *)
      _usr_obselete    = $02; (* USER     OBSELETE Cap headers for QWK msg    *)
      usr_sendxfiles   = $04; (* USER     send xcontrol files                 *)
      usr_selareas     = $08; (* USER     send only areas picked              *)
      usr_qwknetsysop  = $10; (* SYSOP    QWK NETWORK SYSOP                   *)
      usr_PostCredit   = $20; (* SYSOP    Allow for Post Negative Credit      *)
      usr_pktcounter   = $40; (* User     Use a Pkt Counter System for dloads *)
      usr_useflexasst  = $80; (* User     Use a flex on mail scan             *)

(* flag set 2 byte 1 *)

      usr_qwkwordwrap   = $01; (* USER    Word Wrap Message for Qwk Reader    *)
      usr_NoRipGraphics = $02; (* USER    if enabled, don't bother w/ RIP     *)
      usr_srchtext      = $04; (* USER    if enabled, search body of text     *)
      usr_AnsiList      = $08; (* USER    Enable ANSI for New Files 5.03/4.01 *)

      _DEFAULT_USERNAME = 'Default User';
var
    totalgroups  : byte;
    usrgroups    : GroupListType;
    Fvxpuser     : xpuserfiletype;
    Fvxpuserdef  : xpuserfiletype;
    xpuserrec    : _xpusertype;
    xpusernum    : longint;
    NewUsrFile   : boolean;

implementation

end.

